package ueb6;
import java.util.Scanner;

public class Rechner {

	static Scanner sc = new Scanner(System.in);

	public static void main(String[] args) {

		//Endlosschleife
		while(true) {
			String input = "";

			System.out.println("Welche Rechenart soll ausgeführt werden?");
			String op[] = {"Multiplikation", "Division", "Exponent", "Fakultät"};

			System.out.printf("[  %s  |  %s  |  %s  |  %s  ]\n", op[0], op[1], op[2], op[3]);
			System.out.println("[  m  |  d  |  e  |  f  ]");
			System.out.print("Geben Sie das zugehörige Zeichen an: ");

			//Eingabe
			input = sc.nextLine();

			//Fehler bei Zeicheneingabe abfangen
			if (input.length() > 1) {
				System.out.println("Nur ein Zeichen eingeben. Versuche es erneut.");
			} else if (input.length() < 1) {
				System.out.println("Bitte ein Zeichen eingeben. Versuche es erneut.");
			} else {
				//Zeichen herausfinden
				char c = input.charAt(0);

				//Zeichen an berechnung() übergeben
				int ergebnis = berechnung(c);

				//Ergebnis nur ausgeben, wenn Ergebnis nicht -1 ist
				if (ergebnis != -1) {
					System.out.println("Ergebnis: " + ergebnis);
					//Zeilenumruch aus dem Buffer herausfiltern
					sc.nextLine();
				}
			}
			System.out.print("\n");

		}
	}

	/**
	 * Führt die ausgewählte Berechnung basierend auf dem übergebenen Zeichen aus.
	 * @param c Das Zeichen, das die gewünschte Berechnung angibt
	 * ('m' für Multiplikation, 'd' für Division, 'e' für Exponentialfunktion, 'f' für 
	 * Fakultät)
	 * @return Das Ergebnis der Berechnung oder -1 bei fehlerhafter Eingabe
	 */
	public static int berechnung(char c) {
		int ergebnis;

		switch(c) {

		//Bedingung: Multiplizieren
		case 'm': 
			System.out.println("\n* Multiplikation *");
			System.out.print("Ersten Faktor eingeben: ");
			int faktor1 = sc.nextInt();
			System.out.print("Zweiten Faktor eingeben: ");
			int faktor2 = sc.nextInt();

			//Versuche multiplizieren() durchzuführen
			try {
				ergebnis = multiplizieren(faktor1, faktor2);
				return ergebnis;
				//Fange Fehler ab und gebe Nachricht aus
			} catch (IllegalArgumentException e) {
				System.out.println(e.getMessage());
				//Zeilenumruch aus dem Buffer herausfiltern
				sc.nextLine();
				ergebnis = -1;
				return ergebnis;
			}

			//Bedingung: Dividieren
		case 'd': 
			System.out.println("\n* Division *");
			System.out.print("Dividend eingeben: ");
			int dividend = sc.nextInt();
			System.out.print("Divisor eingeben: ");
			int divisor = sc.nextInt();
			//Versuche dividieren() durchzuführen
			try {
				ergebnis = dividieren(dividend, divisor);
				return ergebnis;
				//Fange Fehler ab und gebe Nachricht aus
			} catch (IllegalArgumentException e) {
				System.out.println(e.getMessage());
				//Zeilenumruch aus dem Buffer herausfiltern
				sc.nextLine();
				ergebnis = -1;
				return ergebnis;
				//Fange Fehler (mit 0 dividieren) ab und gebe Nachricht aus
			} catch (ArithmeticException e) {
				System.out.println(e.getMessage());
				//Zeilenumruch aus dem Buffer herausfiltern
				sc.nextLine();
				ergebnis = -1;
				return ergebnis;
			}

			//Bedingung: Exponent
		case 'e': 
			System.out.println("\n* Exponent *");
			System.out.print("Grundwert eingeben: ");
			int grundwert = sc.nextInt();
			System.out.print("Exponent eingeben: ");
			int exponent = sc.nextInt();
			//Versuche exponent() durchzuführen
			try {
				ergebnis = exponent(grundwert, exponent);
				return ergebnis;
				//Fange Fehler ab und gebe Nachricht aus
			} catch (IllegalArgumentException e) {
				System.out.println(e.getMessage());
				//Zeilenumruch aus dem Buffer herausfiltern
				sc.nextLine();
				ergebnis = -1;
				return ergebnis;
			}

			//Bedingung: Fakultät
		case 'f':
			System.out.println("\n* Fakultät *");
			System.out.print("Zahl eingeben: ");
			int n = sc.nextInt();
			//Versuche fakultaet() durchzuführen
			try {
				ergebnis = fakultaet(n);
				return ergebnis;
				//Fange Fehler ab und gebe Nachricht aus
			} catch (IllegalArgumentException e) {
				System.out.println(e.getMessage());
				//Zeilenumruch aus dem Buffer herausfiltern
				sc.nextLine();
				ergebnis = -1;
				return ergebnis;
			}

			// Zeichen stimmt nicht überein
		default: 
			//Gebe Fehlermeldung aus
			System.out.println("Kein gültiges Zeichen eingegeben! Bitte Versuche es erneut.");
			ergebnis = -1;
			return ergebnis;
		}
	}

	/**
	 * Berechnet rekursiv das Produkt von zwei ganzen positiven Zahlen.
	 * @param faktor1 Der erste Faktor
	 * @param faktor2 Der zweite Faktor
	 * @return Das Produkt der beiden Faktoren
	 * @throws IllegalArgumentException Wenn einer der Faktoren negativ ist
	 */
	public static int multiplizieren(int faktor1, int faktor2) {
		if (faktor1 == 0 || faktor2 == 0)
			return 0;
		else if (faktor1 == 1)
			return faktor2;
		else if (faktor2 == 1)
			return faktor1;
		//Wenn eine der Zahlen negativ ist, gebe Fehler mit Meldung zurück
		else if (faktor1 < 0 || faktor2 < 0) {
			throw new IllegalArgumentException("Faktoren dürfen nicht negativ sein!");
		} else 
			return faktor1 + multiplizieren(faktor1, faktor2-1);
	}

	/**
	 * Berechnet rekursiv den Quotienten von zwei ganzen positiven Zahlen.
	 * @param dividend Der Dividend
	 * @param divisor Der Divisor
	 * @return Der Quotient der beiden Zahlen
	 * @throws IllegalArgumentException Wenn einer der Werte negativ ist
	 * @throws ArithmeticException Wenn der Divisor 0 ist
	 * */
	public static int dividieren(int dividend, int divisor) {
		//Wenn Divisor 0 ist, gebe Fehler mit Meldung zurück
		if (divisor == 0)
			throw new ArithmeticException("Durch Null teilen nicht möglich!");
		//Wenn eine der Zahlen negativ ist, gebe Fehler mit Meldung zurück
		else if (dividend < 0 || divisor < 0)
			throw new IllegalArgumentException("Dividend und Divisor dürfen nicht negativ sein!");
		else if (divisor == 1)
			return dividend;
		else if (dividend >= divisor)
			return 1 + dividieren(dividend-divisor, divisor);
		else
			return 0;
	}

	/**
	 * Berechnet rekursiv die Potenz, mit gegebenem positiven ganzen Grundwert und 
	 * Exponenten.
	 * @param grundwert Die Basis
	 * @param exponent Der Exponent der Basis
	 * @return Das Ergebnis der Potenzierung
	 * @throws IllegalArgumentException Wenn einer der Werte negativ ist
	 */
	public static int exponent(int grundwert, int exponent) {
		//Wenn eine der Zahlen negativ ist, gebe Fehler mit Meldung zurück
		if(grundwert < 0 || exponent < 0)
			throw new IllegalArgumentException("Die Basis und der Exponent dürfen nicht negativ sein!");
		else if (exponent == 0)
			return 1;
		else if(grundwert == 1)
			return grundwert;
		else if(exponent == 1)
			return grundwert;
		else {
			return exponent(grundwert, exponent-1) * grundwert;
		}
	}

	/**
	 * Berechnet rekursiv die Fakultät einer ganzen positiven Zahl.
	 * @param n Die Zahl, deren Fakultät berechnet werden soll
	 * @return Die Fakultät der Zahl
	 * @throws IllegalArgumentException Wenn die Zahl negativ ist
	 */
	public static int fakultaet(int n) throws IllegalArgumentException {
		//Wenn Zahl negativ ist, gebe Fehler mit Meldung zurück
		if (n < 0) {
			throw new IllegalArgumentException("Zahl darf nicht negativ sein.");
		} else if (n == 0)
			return 1;
		else {
			return n * fakultaet(n-1);
			
		}
		
	}
}