package ueb6;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


public class TestPacket {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		boolean right = false;
		boolean gestoppt = false;
		//Packstation instanziieren
		Packstation ps = new Packstation();

		//HashMap um Pakete später benennen zu können
		Map<String, Paket> pakete = new HashMap<>();
		
		while(!right) {
			//Auswahl der Packstation-Konstruktoren
			System.out.println("* Packstation wählen *");
			System.out.println("Standardgröße[1] | Benutzerdefinierte Größe[2]");

			//Nutzereingabe
			System.out.print("Auswahl: ");
			int auswahl = sc.nextInt();

			switch(auswahl) {

			case 1: //Auswahl des Standardkonstruktors
				System.out.println("\n* Standardgröße gewählt *");
				System.out.println("Breite: 5, Höhe: 4");
				right = true;
				break;

			case 2: //Auswahl des benutzerdefinierten Konstruktors
				//Eingabe der Werte für den Konstruktor
				System.out.println("\n* Bitte Werte eingeben *");
				System.out.print("Breite: ");
				int breite = sc.nextInt();
				System.out.print("Hoehe: ");
				int hoehe = sc.nextInt();

				//Instanziieren der Klasse
				ps = new Packstation(breite, hoehe);
				System.out.println("\n* Benutzerdefinierte Größe gewählt *");
				System.out.printf("Breite: %d, Höhe: %d\n", breite, hoehe);
				right = true;
				break;

			default: //Fehlerhafte Eingabe
				System.out.println("\nFehlerhafte Eingabe! Bitte versuchen Sie es erneut.\n");
			}
		}

		while(!gestoppt) {
			//Auswahl der auszuführenden Methode
			System.out.println("\n* Operation wählen *");
			System.out.println("Paket ablegen[1] | Freie Boxen zählen[2] | Information zum Boxenplatz[3] | Programm beenden[4]");

			//Nutzereingabe
			System.out.print("Auswahl: ");
			int auswahl = sc.nextInt();
			sc.nextLine();

			switch(auswahl) {

			case 1:
				System.out.println("\n* Paket ablegen gewählt *");

				//Nutzereingabe für Konstruktor: Empfaenger
				System.out.print("Name: ");
				String name = sc.nextLine();

				//Nutzereingabe für Konstruktor: Adresse
				System.out.print("Adresse: ");
				String adresse = sc.nextLine();

				//Nutzereingabe zur Benennung des Objekts
				System.out.print("Paketbezeichnung: ");
				String paketname = sc.nextLine();
				
				//Übernimmt Paket *Variablenname* = new Paket(String empfaenger, String adresse)
				pakete.put(paketname, new Paket(name, adresse));

				try {
					//Ablegen des Pakets
					ps.legePaketAb(pakete.get(paketname));

				}
				//Fehlermeldung falls Box voll
				catch (IllegalStateException e) {
					System.out.println(e.getMessage());
				}
				break;

			case 2:
				System.out.println("\n* Freie Boxen zählen gewählt *");

				//Freie Boxen zählen
				int freieBoxen = ps.zaehleFreieBoxen();
				if (freieBoxen == 1)
					System.out.println("Es ist " + ps.zaehleFreieBoxen() + " Box verfügbar.");
				else
					System.out.println("Es sind " + ps.zaehleFreieBoxen() + " Boxen verfügbar.");
				break;

			case 3:
				System.out.println("\n* Information zum Boxenplatz *");

				//Formatierte Ausgabe der Packstation-Boxen
				ps.printStation();

				//Nutzereingabe für Spalte
				System.out.print("\nSpalte wählen: ");
				int spalte = sc.nextInt();

				//Nutzereingabe für Reihe
				System.out.print("Reihe spalten: ");
				int reihe = sc.nextInt();

				//Ausgabe der Information
				System.out.println("\n" + ps.informationZumBoxenplatz(spalte, reihe));
				break;

			case 4: 
				//Schließen des Programmes
				System.out.println("\n* Programm wird beendet * ");
				gestoppt = true;
				break;
			}
		}
		sc.close();
	}
}
